-- Config Panel Text Strings
AchSnd.Text={
Title = "Achievement Sounds",
TitleSub = "Change how Achievement Sounds behaves by setting the options below",
Enable = "Enable the Add On to function",
Guild = "Trigger on guild member achievements",
Party = "Trigger on party member achievements",
Near  = "Trigger for people near you's achievements",
PvP = "Announce achievements when you are in an active PvP zone",
MSBT  = "Enable output to MSBT's notification frame",
Popup = "Enable Grats popup for 1-click gratting",
Sound = "Enable sound to notify you of an achievement",
CustomMP3 = "Enable custom alert.mp3 sound",
CustomOGG = "Enable custom alert.ogg sound",
Timeout = "Set the pop up's timeout",
Random = "Display a random grats message(checked) or default message",
Flourishes = "Display flourishes on random grat messages",
RaidIcons = "Use Raid Icons in party/guild flourishes",
Names = "Use playes's names in grat messages",
NNames = "Use Nicknames in grats when saved",
MaxNames = "Max number of names to display",
Multi = "Respond to multiple achievements with plural random msg",
MultiAmount = "    Over this amount gives a whole guild grat.",
DefaultMsg = "The message displayed if Random is off",
NewMsgBox = "Use the new \"Achievement Alert\" frame instead of old popup style. (Still needs Popup enabled to function)",
AutoFade = "Enable the new frame to fade when the mouse isn't over it",
MinAlpha = "The min. alpha the frame will fade to",
FadeDelay = "Time before frame fades to above"
}

-- Bill's Utils
local Wait = BillsUtils.Wait
local ChkBoxSave = BillsUtils.ChkBoxSave
local SliderSave = BillsUtils.SliderSave
local SliderMW = BillsUtils.SliderMW
local ChkBox = BillsUtils.ChkBox -- function( Last , Prefix, Name, Parent, Click, TextTable )
local CheckClick = BillsUtils.CheckClick
local Slider = BillsUtils.Slider
local SliderEditBox = BillsUtils.SliderEditBox
local EditBox = BillsUtils.EditBox

BillsUtils.Locals[#BillsUtils.Locals +1] = function () --function is called if/when a newer version of Bill's Utils loads after the addon is loaded
	Wait = BillsUtils.Wait
	ChkBoxSave = BillsUtils.ChkBoxSave
	SliderSave = BillsUtils.SliderSave
	SliderMW = BillsUtils.SliderMW
	ChkBox = BillsUtils.ChkBox
	CheckClick = BillsUtils.CheckClick
	Slider = BillsUtils.Slider
	SliderEditBox = BillsUtils.SliderEditBox
	EditBox = BillsUtils.EditBox
end

-- General Settings / functions

--Panel
AchSnd.panel = CreateFrame( "Frame", "AchSndConfig", UIParent )
AchSnd.panel2 = CreateFrame( "Frame", "AchSndConfig", AchSnd.panel )
local me = AchSnd.panel
local me2 = AchSnd.panel2

me.name = "Ach. Sounds"
me2:SetSize(380,475)
me2:SetPoint("BOTTOMLEFT", me, "BOTTOMLEFT")


local X = 16 -- standard Horizontal Spacing
local Y = 35 -- standard Vertical spacing 26
local TxtY = 13

-- Pane title
	local Title = me:CreateFontString( nil, "ARTWORK", "GameFontNormalLarge" )
	Title:SetPoint( "TOPLEFT", 16, -16 )
	Title:SetText( AchSnd.Text.Title )
	local SubText = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	SubText:SetPoint( "TOPLEFT", Title, "BOTTOMLEFT", 0, -8 )
	SubText:SetPoint( "RIGHT", -32, 0 )
	SubText:SetHeight( 32 )
	SubText:SetJustifyH( "LEFT" )
	SubText:SetJustifyV( "TOP" )
	SubText:SetText( AchSnd.Text.TitleSub )

-- Scroll Frame
	me.ScrollFrame = CreateFrame("ScrollFrame", "AchSndConfigScrollFrame", me, "UIPanelScrollFrameTemplate")
	me.ScrollFrame:SetScrollChild(me2)
	me.ScrollFrame:SetPoint("TOPRIGHT", me ,"TOPRIGHT", -30,- 64)
	me.ScrollFrame:SetPoint("BOTTOMRIGHT", me ,"BOTTOMRIGHT", -30, 10)
	me.ScrollFrame:SetPoint("BOTTOMLEFT", me ,"BOTTOMLEFT", 30, 10)
	--me.ScrollFrame:SetSize(390, 400)


local Command = { "Enable", "Guild", "Party", "Near", "PvP",
	"MSBT", "Popup", "Sound", "CustomMP3", "CustomOGG", 
	"Timeout", "Random", "Flourishes", "RaidIcons", "Names",
	"NNames", "MaxNames", "Multi", "MultiAmount", "DefaultMsg",
	"NewMsgBox", "AutoFade", "MinAlpha", "FadeDelay"}

local CmdType = { 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1,
	2, 1, 1, 1, 1,
	1, 2, 1, 2, 3,
	1, 1, 2, 2}
-- 1 = checkbox   2 = slider   3 = editbox
local options = { 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0,
	{0, 60, 1}, 0, 0, 0, 0,
	0, {1, 10, 1}, 0, {0, 129, 1},0,
	0, 0, {0, 100, 5}, {0, 60, .5} }

local last = me2
for x = 1, #Command do
	if CmdType[x] == 1 then
		me[Command[x]] = ChkBox( last , "AchSndCfg", Command[x], me2, CheckClick, AchSnd.Text )
	elseif CmdType[x] == 2 then
		me[Command[x]] = Slider( last , "AchSndCfg", Command[x], me2 , SliderMW , AchSnd.Text, options[x][1], options[x][2], options[x][3] )
		me[Command[x]].Val = SliderEditBox( me[Command[x]] , "AchSndCfg", Command[x], me2 )
	elseif CmdType[x] == 3 then
		me[Command[x]] = EditBox( last, "AchSndCfg", Command[x], me2, nil, Command[x], AchSnd.Text )
	end
	last = me[Command[x]]
end
	
-- Frame Settings Test Button 
	me.TestButton = CreateFrame("Button", "AchSndTestButton", me2, "UIPanelButtonTemplate" )
	me.TestButton:SetPoint("TOPLEFT", last, "TOPLEFT", ((me2:GetWidth() / 2) -75) , -Y )
	me.TestButton:SetSize( 150, 25)
	me.TestButton:SetText("Test")
	me.TestButton:SetScript("OnClick", function(self, button, down)
		if (button ~= "LeftButton") then
			return
		end
		PlaySound( "GAMEGENERICBUTTONPRESS" )
		AchSnd.MBox.Test = true
		AchSnd.MBox.text = "This is a test for checking the Alpha of the frame"
		GameMenuFrame:Hide()
		InterfaceOptionsFrame:Hide()
		AchSnd.MsgFrame:Show()
		return
	end)
	
--	End of frame
-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
-- X  Init / Reset the config panel to match current settings                                                     X
-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
--


AchSnd.Init = function(...)
	if (AchSnd.MBox.mode == "TEST") then
		return
	end
	
	local setting = AchSnd_Settings
	local me = AchSnd.panel
	
	local Command = { "Enable", "Guild", "Party", "Near", "PvP",
	"MSBT", "Popup", "Sound", "CustomMP3", "CustomOGG", 
	"Timeout", "Random", "Flourishes", "RaidIcons", "Names",
	"NNames", "MaxNames", "Multi", "MultiAmount", "DefaultMsg",
	"NewMsgBox", "AutoFade", "MinAlpha", "FadeDelay"}

	local CmdType = { 1, 1, 1, 1, 1,
		1, 1, 1, 1, 1,
		2, 1, 1, 1, 1,
		1, 2, 1, 2, 3,
		1, 1, 2, 2}
	-- 1 = checkbox   2 = slider   3 = editbox

	for x = 1, #Command do
		if CmdType[x] == 1 then
			me[Command[x]]:SetChecked( AchSnd_Settings[Command[x]] )
		elseif CmdType[x] == 2 then
			me[Command[x]]:SetValue( AchSnd_Settings[Command[x]] )
			me[Command[x]].Val:SetCursorPosition( 0 )
			me[Command[x]].Val:SetNumber( AchSnd_Settings[Command[x]] )
		elseif CmdType[x] == 3 then
			me[Command[x]]:SetCursorPosition( 0 )
			me[Command[x]]:SetText( AchSnd_Settings[Command[x]] )
		end
	end
end

-- Reset config panel and settings to DEFAULT
AchSnd.Reset = function(...)
	local Command = {"Enable", "Guild", "Party", "Near", "PvP", 
		"MSBT", "Popup", "Timeout", "Sound", "CustomMP3",
		"CustomOGG", "Random", "Flourishes", "RaidIcons", "Names",
		"NNames", "MaxNames", "Multi", "MultiAmount", "DefaultMsg",
		"NewMsgBox", "AutoFade", "MinAlpha", "FadeDelay" }
	
	for x = 1, #Command do
		AchSnd_Settings[Command[x]] = AchSnd_Defaults[Command[x]]
	end
	
	AchSnd.Init()
end



me.refresh = function(self)
	AchSnd.Init()
end

me.default = function (self)
	AchSnd.Reset()
end

me.cancel = function (self)
	AchSnd.Init()
end


-- Save settings from config panel
me.okay = function(self)
	-- CheckBoxes
	local Command = {"Enable", "Guild", "Party", "Near", "PvP", 
		"MSBT", "Popup", "Sound", "CustomMP3", "CustomOGG",
		"Random", "Flourishes", "RaidIcons", "Names", "NNames",
		"Multi", "NewMsgBox", "AutoFade" }
	for x = 1, #Command do
		ChkBoxSave( AchSnd.panel, Command[x], AchSnd_Settings) 
	end
	
	-- Sliders
	local Command = {"Timeout", "MaxNames", "MultiAmount", "MinAlpha", "FadeDelay"}
	for x = 1, #Command do
		SliderSave( AchSnd.panel, Command[x], AchSnd_Settings)
	end
	
	-- Default Message EditBox
	if (me.DefaultMsg:GetText() ~= AchSnd_Settings.DefaultMsg) then
		setting.DefaultMsg = me.Default:GetText()
	end
	
end

-- Register the config panel
InterfaceOptions_AddCategory( me )


-- ****************************************************************************
-- * Nick Name Child Panel -- -- -- UNDER CONSTRUCTION                        *
-- ****************************************************************************


--Panel
AchSnd.panel3 = CreateFrame( "Frame", "AchSndNNConfig", UIParent )
local me = AchSnd.panel3
me.NButtons = {}
me.NNButtons = {}

me.name = "Nick Names"
me.parent = AchSnd.panel.name

local X = 16 -- standard Horizontal Spacing
local Y = 35 -- standard Vertical spacing 26
local TxtY = 13
local e = 0

AchSnd.EBoxUpdate = function(count)
	local NN = AchSnd.NNTable
	local maxcount = #NN.Names
	local slider = me.slider:GetValue()
	
	if count + slider > maxcount then
		me.NBox:SetText("")
		me.NNBox:SetText("")
	else
		me.NBox:SetText(NN.Names[count + slider])
		me.NNBox:SetText(NN.Nicks[count + slider])
	end
end


AchSnd.NNDisplayUpdate = function()
	local NN = AchSnd.NNTable
	local maxcount = #NN.Names
	local slider = me.slider:GetValue()
	
	
	for x = 1 , 10 do
		if x + slider > maxcount then
			me.NButtons[x]:SetText( " " )
			me.NNButtons[x]:SetText( " " )
		else
			me.NButtons[x]:SetText( NN.Names[x + slider] )
			me.NNButtons[x]:SetText( NN.Nicks[x + slider] )
		end
	end
	me.slider:SetMinMaxValues( 0, (#NN.Names > 10 and #NN.Names - 10) or 1 )
end


-- Pane title
local Title = me:CreateFontString( nil, "ARTWORK", "GameFontNormalLarge" )
Title:SetPoint( "TOPLEFT", 16, -16 )
Title:SetText( "Nick Names" )
local SubText = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
SubText:SetPoint( "TOPLEFT", Title, "BOTTOMLEFT", 0, -8 )
SubText:SetPoint( "RIGHT", -32, 0 )
SubText:SetHeight( 32 )
SubText:SetJustifyH( "LEFT" )
SubText:SetJustifyV( "TOP" )
SubText:SetText( "Setup your aliases here"  )
	
local last = me
local width = 150

for x = 1, 10 do
	me.NButtons[x] = CreateFrame("Button", "AchSndNameListButton"..tostring(x), me, "UIPanelButtonTemplate" )
	me.NNButtons[x] = CreateFrame("Button", "AchSndNNameListButton"..tostring(x), me, "UIPanelButtonTemplate" )
	if last == me then
		me.NButtons[x]:SetPoint("TOPLEFT", last, "TOPLEFT", 20, -60 )
	else
		me.NButtons[x]:SetPoint("TOPLEFT", last, "BOTTOMLEFT" )
	end
	me.NButtons[x]:SetSize( width , 20)
	me.NButtons[x]:SetText( " " )
	me.NButtons[x].count = x
	me.NButtons[x]:SetScript("OnClick", function(self, button, down)
		if (button ~= "LeftButton") then
			return
		end
		PlaySound( "GAMEGENERICBUTTONPRESS" )
		AchSnd.EBoxUpdate( self.count )
		return
	end)
	
	me.NNButtons[x]:SetPoint("TOPLEFT", me.NButtons[x], "TOPRIGHT" )
	me.NNButtons[x]:SetSize( width , 20)
	me.NNButtons[x]:SetText( " " )
	me.NNButtons[x].count = x
	me.NNButtons[x]:SetScript("OnClick", function(self, button, down)
		if (button ~= "LeftButton") then
			return
		end
		PlaySound( "GAMEGENERICBUTTONPRESS" )
		AchSnd.EBoxUpdate( self.count )
		return
	end)
	last = me.NButtons[x]
end

me.slider = CreateFrame( "Slider", "NAlertNNSlider", me, "OptionsSliderTemplate" )
me.slider:SetMinMaxValues( 0, 1 )
me.slider:SetOrientation("VERTICAL")
me.slider:SetPoint("TOPLEFT", me.NNButtons[1] ,"TOPRIGHT", 5 , 0)
me.slider:SetPoint("BOTTOMLEFT", me.NNButtons[10] ,"BOTTOMRIGHT", 5 , 0)
me.slider:SetValueStep( 1 )
me.slider:SetValue( 0 )
me.slider:SetWidth( 16 )	
me.slider:SetScript( "OnValueChanged", function( self )
	PlaySound( "GAMEGENERICBUTTONPRESS" )
	AchSnd.NNDisplayUpdate()
end)
getglobal(me.slider:GetName() .. 'Low'):SetText( "" )
getglobal(me.slider:GetName() .. 'High'):SetText( "" )
me.slider:SetScript("OnMouseWheel", function(self, delta)
	SliderMW(self, -delta)
end)

local eboxwidth = 150

me.NBox = CreateFrame( "EditBox", "AchSndNEditbox", me, "InputBoxTemplate" )
me.NBox:SetFontObject("ChatFontNormal")
me.NBox:SetTextInsets(0, 0, 3, 3)
me.NBox:SetPoint("BOTTOMLEFT", me , "BOTTOMLEFT", 30 , 50 )
--me.NBox:SetPoint("RIGHT", -32, 0)
me.NBox:SetHeight(19)
me.NBox:SetWidth( eboxwidth )
me.NBox:SetAutoFocus(false)
me.NBox:SetMaxLetters( 254 )
me.NBox:SetScript("OnEnterPressed" , function(self)
	self:ClearFocus()
end)
me.NBox:SetScript("OnEscapePressed", function(self)
	self:SetText( "" )
	self:ClearFocus()
end)

me.NBox.Text = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
me.NBox.Text:SetPoint( "BOTTOMLEFT", me.NBox , "BOTTOMLEFT", 0 , Y/4 )
me.NBox.Text:SetPoint( "RIGHT", -32, 0 )
me.NBox.Text:SetHeight( 32 )
me.NBox.Text:SetJustifyH( "LEFT" )
me.NBox.Text:SetJustifyV( "TOP" )
me.NBox.Text:SetText( "Name:" )

me.NNBox = CreateFrame( "EditBox", "AchSndNNEditbox", me, "InputBoxTemplate" )
me.NNBox:SetFontObject("ChatFontNormal")
me.NNBox:SetTextInsets(0, 0, 3, 3)
me.NNBox:SetPoint("BOTTOMLEFT", me.NBox , "BOTTOMRIGHT", 40, 0 )
-- me.NNBox:SetPoint("RIGHT", -32, 0)
me.NNBox:SetHeight(19)
me.NNBox:SetWidth( eboxwidth )
me.NNBox:SetAutoFocus(false)
me.NNBox:SetMaxLetters( 254 )
me.NNBox:SetScript("OnEnterPressed" , function(self)
	self:ClearFocus()
end)
me.NNBox:SetScript("OnEscapePressed", function(self)
	self:SetText( "" )
	self:ClearFocus()
end)

me.NNBox.Text = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
me.NNBox.Text:SetPoint( "BOTTOMLEFT", me.NNBox , "BOTTOMLEFT", 0 , Y/4 )
me.NNBox.Text:SetPoint( "RIGHT", -32, 0 )
me.NNBox.Text:SetHeight( 32 )
me.NNBox.Text:SetJustifyH( "LEFT" )
me.NNBox.Text:SetJustifyV( "TOP" )
me.NNBox.Text:SetText( "Nickname:" )

me.AddButton = CreateFrame("Button", "AchSndNNAddButton", me, "UIPanelButtonTemplate" )
me.AddButton:SetPoint("BOTTOMLEFT", me, "BOTTOMLEFT", 20 , 20 )
me.AddButton:SetSize( 150, 25)
me.AddButton:SetText("Add")
me.AddButton:SetScript("OnClick", function(self, button, down)
	if (button ~= "LeftButton") then
		return
	end
	PlaySound( "GAMEGENERICBUTTONPRESS" )
	if #me.NNBox:GetText() < 2 then
		return
	end

	AchSnd.Add( me.NBox:GetText(), me.NNBox:GetText() )
	me.NBox:SetText("")
	me.NBox:ClearFocus()
	me.NNBox:SetText("")
	me.NNBox:ClearFocus()
	AchSnd.NNDisplayUpdate()
	return
end)

me.DeleteButton = CreateFrame("Button", "AchSndNNDeleteButton", me, "UIPanelButtonTemplate" )
me.DeleteButton:SetPoint("BOTTOMRIGHT", me, "BOTTOMRIGHT", -20 , 20 )
me.DeleteButton:SetSize( 150, 25)
me.DeleteButton:SetText("Delete")
me.DeleteButton:SetScript("OnClick", function(self, button, down)
	if (button ~= "LeftButton") then
		return
	end
	PlaySound( "GAMEGENERICBUTTONPRESS" )
	AchSnd.Rem( me.NBox:GetText() )
	me.NBox:SetText("")
	me.NBox:ClearFocus()
	me.NNBox:SetText("")
	me.NNBox:ClearFocus()
	AchSnd.NNDisplayUpdate()
	return
end)

me:SetScript("OnUpdate", function(self, elapsed)
	e = e + elapsed
	if e < (1/10) then 
		return
	end
	e = 0
	if me.NButtons[1]:GetText() == " " then
		AchSnd.NNDisplayUpdate()
	end
	
end)

InterfaceOptions_AddCategory( me )

